/**
 * Custom Parallax CK
 * @copyright	Copyright (C) 2012 Cedric KEIFLIN alias ced1870
 * https://www.joomlack.fr
 * Module Maximenu CK
 * @license		GNU/GPL
 * */

// v2.0.0	- 03/02/22 : new script for Joomla 4

(function($) {

	//define the defaults for the plugin and how to call it
	var Customparallaxck = function (container, options) {

		//set default options
		var defaults = {
			xpos: '50%',			// background image position in X | numeric value in px, %, or use center, top, etc
			offsety: 0,				// vertical offset to move the image at the correct starting point | numeric value
			speedFactor: 0.1,		// speed factor | numeric value
			outerHeight: true,		// option to use if there is any issue with the dimensions of the elements | true or false
			modHeight: '60%',		// minimum height to give to the container | % or px
			responsiveFont: true,	// you can choose if you want the font to be resized with the window | true or false
			resizeFactorText: 1		// coefficient used to scale the text according to the screen resolution | numeric value
		};
console.log(defaults);
console.log(options);
		if (!(this instanceof Customparallaxck)) return new Customparallaxck(container, options);
		var Customparallaxcks = window.Customparallaxcks || [];
		if (Customparallaxcks.indexOf(container) > -1) return;
		Customparallaxcks.push(container);
		window.Customparallaxcks = Customparallaxcks;

		//call in the default otions
		var opts = $.extend(defaults, options);
		var $wrap = $(container);
		var $window = $(window);
		var windowHeight = $window.height();
		var getHeight;
console.log(opts.modHeight);
		if (opts.outerHeight) {
			getHeight = function(jqo) {
				return jqo.outerHeight(true);
			};
		} else {
			getHeight = function(jqo) {
				return jqo.height();
			};
		}

		// function to be called whenever the window is scrolled or resized
		function update(){
			var pos = $window.scrollTop();

			$wrap.find('.customparallaxck').each(function(){
				var $layer = $(this);

				var top = $wrap.offset().top
				var height = getHeight($wrap);
				var speedFactor = $layer.attr('data-speedfactor') || opts.speedFactor;
				var xpos = $layer.attr('data-xpos') || opts.xpos;
				var offsety = $layer.attr('data-offsety') || opts.offsety;

				// check if totally above or totally below viewport
				if (top + height < pos || top > pos + windowHeight) {
					$wrap.removeClass('animateck');
					return;
				}

				// animate the content if found
				if ($wrap.find('> .customparallaxck_content_cont').length) {
					var captiontop = $wrap.find('> .customparallaxck_content_cont').offset().top;
					var captionheight = getHeight($wrap.find('> .customparallaxck_content_cont'));

					if (captiontop < pos || captiontop > pos + windowHeight - 30) {
						// is out of the screen
					} else {
						$wrap.addClass('animateck');
					}
				}

				// var bgy = (parseFloat(offsety) / height * 100) + Math.round( ((top - pos) * speedFactor) + parseInt(offsety) )  / height * 100;
				var bgy = (parseFloat(offsety) / height * 100) + Math.round( ((top - pos) * speedFactor) )  / height * 100;
				var r = $wrap.width() / 1000; // base width for the calcul is 1000px
				// move the layer
				$layer.css('top', (bgy * r) + "%");
			});
		}		
		
		function resize(){
			windowHeight = $window.height();
			// check if the height is in %, resize else do nothing
			if (opts.modHeight.indexOf('%') != -1) {
				$wrap.css('min-height', ($wrap.width() * parseFloat(opts.modHeight) / 100));
			}
			// resize the font size
			if (opts.responsiveFont) {
				$wrap.css('font-size', ($wrap.width() / 1000 * parseFloat(opts.resizeFactorText)) + 'em');
			}
			update();
		}

		$window.bind('scroll', update).resize(resize);
		update();
		resize();
	};
	window.Customparallaxck = Customparallaxck;
})(jQuery);
